#include <bits/stdc++.h>
using namespace std;


using ll = long long;

#define citers(c) c.begin(), c.end()


#pragma GCC target("lzcnt")


static inline void _io_speedup [[maybe_unused]] ()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}


struct SparseTable
{
	int lgn;
	vector<vector<int>> table;

	SparseTable(const vector<int> & v, int n) : lgn(__lg(n)), table(lgn + 1, vector<int>(n))
	{
		copy(citers(v), table[0].begin());
		for (int k = 0; k < lgn; ++k)
		{
			int undlen = 1 << k;
			int curlen = undlen << 1;
			for (int l = 0; l + curlen <= n; ++l)
				table[k + 1][l] = table[k][l] | table[k][l + undlen];
		}
	}

	// value on [l; r]
	int get(int l, int r)
	{
		++r;
		int k = __lg(r - l);
		return table[k][l] | table[k][r - (1 << k)];
	}
};


// fwd - decreasing
// bwd - decreasing
// 0 - decreasing, 1 - increasing/stays equal
int main()
{
	_io_speedup();

	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) cin >> a[i];
	if (n == 1)
	{
		cout << 1 << endl;
		return 0;
	}

	vector<int> vdiff_fwd(n, 0), vdiff_bwd(n, 0);
	for (int i = 1; i < n; ++i) vdiff_fwd[i] = a[i] >= a[i - 1];
	for (int i = n - 2; i >= 0; --i) vdiff_bwd[i] = a[i] >= a[i + 1];

	SparseTable diff_fwd(vdiff_fwd, n), diff_bwd(vdiff_bwd, n);

	ll ans = 0;
	for (int i = 0; i < n; ++i)
	{
		// l, r - (max len for a part) - 1
		// l - can, r - cannot => answer in l

		// bin search left border
		int back_l = 0, back_r = i + 1;
		int spt_sr = i - 1;
		while (back_l + 1 < back_r)
		{
			int mid = (back_l + back_r) / 2;
			if (diff_bwd.get(i - mid, spt_sr) == 0)
				back_l = mid;
			else
				back_r = mid;
		}

		// bin search right border
		int spt_sl = i + 1;
		int fw_l = 0, fw_r = n - i;
		while (fw_l + 1 < fw_r)
		{
			int mid = (fw_l + fw_r) / 2;
			if (diff_fwd.get(spt_sl, i + mid) == 0)
				fw_l = mid;
			else
				fw_r = mid;
		}

		ll l_cnt = back_l + 1;
		ll r_cnt = fw_l + 1;
		ans += l_cnt * r_cnt;
	}

	cout << ans << endl;
	return 0;
}